<template>
  <b-card class="animated fadeIn" title="Cập nhật thông tin nhân viên">
    <b-tabs>
      <b-tab title="Thông tin" active>
        <b-row v-if="salesman != null">
          <b-col sm="6">
            <b-form-group>
              <label for="name">Tên nhân viên</label>
              <b-form-input type="text" id="name" name="name" v-model="salesman.name" data-vv-as="Tên nhân viên"
                v-validate="'required'" :class="{'is-invalid': errors.has('name')}"></b-form-input>
              <span v-show="errors.has('name')" class="form-text text-muted text-danger">{{
                errors.first('name') }}</span>
            </b-form-group>
            <b-form-group>
              <label for="email">Email</label>
              <b-form-input type="text" id="email" name="name" v-model="salesman.email" data-vv-as="Email" v-validate="'required|email'"
                :class="{'is-invalid': errors.has('email')}"></b-form-input>
              <span v-show="errors.has('email')" class="form-text text-muted text-danger">{{
                errors.first('email') }}</span>
            </b-form-group>
            <b-form-group>
              <label for="phone">SĐT</label>
              <b-form-input type="text" id="phone" name="phone" v-model="salesman.phone" data-vv-as="SĐT" v-validate="'required|min:9'"
                :class="{'is-invalid': errors.has('phone')}"></b-form-input>
              <span v-show="errors.has('phone')" class="form-text text-muted text-danger">{{
                errors.first('phone') }}</span>
            </b-form-group>
            <b-button variant="success" @click.stop="validateBeforeSubmit()">Save</b-button>
          </b-col>
        </b-row>
      </b-tab>
      <b-tab title="Đổi Mật khẩu">
         <b-col sm="6">
        <b-form-group>
          <label for="password">Mật khẩu</label>
            <b-form-input type="password" id="password" name="password" v-model="password"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label for="re_password">Nhập lại Mật khẩu</label>
            <b-form-input type="password" id="re_password" name="re_password" v-model="re_password"></b-form-input>
        </b-form-group>
        <b-form-group>
          <span class="text-danger">{{ reset_pwd_error }}</span>
         <b-button variant="success" class="pull-right" @click.stop="resetPassword()">Save</b-button>
        </b-form-group>

        </b-col>
      </b-tab>
      <b-tab title="Đại lý" v-if="this.salesman != null">
        <b-row>
          <b-col>
            <button class="pull-right btn btn-primary my-1" @click="enableAddingMode()"><i class="fa fa-plus fa-lg"></i>
              Thêm đại lý</button>
          </b-col>
        </b-row>

        <b-row>
          <b-col>
            <b-row>
              <b-col md="3" class="my-1">
                <b-form-group horizontal label="Hiển thị">
                  <b-form-select :options="pageOptions" v-model="perPage" />
                </b-form-group>
              </b-col>
            </b-row>
            <b-table striped hover :responsive="true" :items="salesman.agencies" :fields="addMode ? shorterFields : fields"
              :current-page="currentPage" :per-page="perPage">

              <template slot="HEAD_select" slot-scope="foo">
                <!-- We use click.native.stop here to prevent 'sort-changed' or 'head-clicked' events -->
                <b-form-checkbox @click.native.stop :value="foo.column" v-model="selected" />
              </template>
              <template slot="select" slot-scope="row">
                <b-form-checkbox v-model="selected" :value="row.item.id">
                </b-form-checkbox>


              </template>
              <template slot="actions" slot-scope="row" v-if="!addMode">
                <!-- We use @click.stop here to prevent a 'row-clicked' event from also happening -->

              </template>
              <template slot="back" slot-scope="row">
                <div v-if="row.item.isNew == 1"></div>
                  <!-- We use click.native.stop here to prevent 'sort-changed' or 'head-clicked' events -->
                  <b-button @click.stop="giveBackAgency(row.item, row.index, $event.target, false)" size="sm" variant="danger"><i
                      class="fa fa-chevron-right fa-sm"></i></b-button>
                </template>
            </b-table>
          </b-col>
          <b-col v-if="addMode">
            <b-row>
              <b-col md="3" class="my-1">
                <b-form-group horizontal label="Hiển thị">
                  <b-form-select :options="agencyPageOptions" v-model="agencyPerPage" />
                </b-form-group>
              </b-col>
              <b-col>
                <b-button variant="primary" @click="addAllAgency()">Thêm tất cả</b-button>
                 <b-button variant="success" class="pull-right" @click="syncAgencies()">Hoàn thành</b-button>
                  <b-button variant="warning" class="pull-right" @click="addMode = false">Cancel</b-button>
              </b-col>
            </b-row>

            <div v-if="this.hasNoSaleAgencies">
              <b-table striped hover :responsive="true" :items="allAgencies" :fields="hasAddButtonFields" :current-page="agencyCurrentPage"
                :per-page="agencyPerPage">

                <template slot="HEAD_select" slot-scope="foo">
                  <!-- We use click.native.stop here to prevent 'sort-changed' or 'head-clicked' events -->
                  <b-form-checkbox @click.native.stop :value="foo.column" v-model="selected" />
                </template>
                <template slot="add" slot-scope="row">
                  <!-- We use click.native.stop here to prevent 'sort-changed' or 'head-clicked' events -->
                  <b-button @click.stop="addAgency(row.item, row.index, $event.target, false)" size="sm" variant="success"><i
                      class="fa fa-chevron-left fa-sm"></i></b-button>
                </template>
                <template slot="select" slot-scope="row">
                  <b-form-checkbox v-model="selected" :value="row.item.id">
                  </b-form-checkbox>


                </template>
                <template slot="actions" slot-scope="row" v-if="!addMode">
                  <!-- We use @click.stop here to prevent a 'row-clicked' event from also happening -->

                </template>
              </b-table>
            </div>
            <div class="text-center" v-else>
              <span class="text-center text-danger font-weight-bold">
                Tất cả đại lý đều đã có nhân viên giao dịch.
              </span>
            </div>

          </b-col>
        </b-row>
        <b-row>
          <b-col md="6" class="my-1">
            <b-pagination :total-rows="totalRows" :per-page="perPage" v-model="currentPage" class="my-0" />
          </b-col>
                    <b-col v-if="addMode" md="6" class="my-1">
            <b-pagination :total-rows="agencyTotalRows" :per-page="agencyPerPage" v-model="agencyCurrentPage" class="my-0" />
          </b-col>
        </b-row>
      </b-tab>
    </b-tabs>
  </b-card>
</template>
<script>
import { http } from "@/services";
import { alerts } from "@/utils";
export default {
  data() {
    return {
      salesman: null,
      id: this.$route.params.saleId,
      fields: [
        {
          key: "select",
          label: "",
          sortable: false
        },
        {
          key: "id",
          label: "Mã ĐL",
          sortable: true
        },
        {
          key: "name",
          label: "Tên đại lý",
          sortable: true
        },
        {
          key: "owner.fullname",
          label: "Chủ đại lý",
          sortable: true
        },
        {
          key: "province.name",
          label: "Tỉnh/Thành",
          sortable: true
        },
        {
          key: "district.name",
          label: "Quận/Huyện",
          sortable: true
        },
        {
          key: "ward.name",
          label: "Xã/Phường",
          sortable: true
        },
        {
          key: "actions",
          label: "Actions"
        }
      ],
      shorterFields: [
        {
          key: "id",
          label: "Mã ĐL",
          sortable: true
        },
        {
          key: "name",
          label: "Tên đại lý",
          sortable: true
        },

        {
          key: "province.name",
          label: "Tỉnh/Thành",
          sortable: true
        },
        {
          key: "back",
          label: "",
          sortable: false
        }
      ],
      hasAddButtonFields: [
        {
          key: "add",
          label: "",
          sortable: false
        },
        {
          key: "select",
          label: "",
          sortable: false
        },
        {
          key: "id",
          label: "Mã ĐL",
          sortable: true
        },
        {
          key: "name",
          label: "Tên đại lý",
          sortable: true
        },

        {
          key: "province.name",
          label: "Tỉnh/Thành",
          sortable: true
        }
      ],
      allAgencies: null,
      fullFields: [],
      selected: [],
      selectAll: false,
      password: "",
      re_password: "",
      reset_pwd_error: "",
      currentPage: 1,
      perPage: 10,
      totalRows: 0,
      pageOptions: [5, 10, 15],
      addMode: false,
      agencyCurrentPage: 1,
      agencyPerPage: 10,
      agencyTotalRows: 0,
      agencyPageOptions: [5, 10, 15]
    };
  },
  created() {
    this.fetchSalesman();
  },
  watch: {
    addMode: function(oldAddMode, newAddMode) {
      if (oldAddMode) {
        document.body.classList.remove("sidebar-lg-show");
      } else {
        document.body.classList.add("sidebar-lg-show");
      }
    }
  },
  methods: {
    fetchSalesman() {
      http.post(
        "/salesman",
        {
          id: this.id
        },
        response => {
          this.salesman = response.data;
        }
      );
    },
    select() {
      this.selected = [];
      if (!this.selectAll) {
        for (let i in this.items) {
          this.selected.push(this.items[i].id);
        }
      }
    },
    resetPassword() {
      this.reset_pwd_error = "";
      if (this.password.length < 6) {
        this.reset_pwd_error = "Mật khẩu phải có độ dài tối thiểu 6 ký tự";
      } else if (this.password !== this.re_password) {
        this.reset_pwd_error = "Mật khẩu và mật khẩu nhập lại chưa khớp";
      } else {
        http.post(
          "/user/resetpassword",
          { user_id: this.id, password: this.password },
          response => {
            if (response.data.status) {
              alerts.success(response.data.msg);
            } else {
              alerts.danger(response.data.msg);
            }
          }
        );
      }
    },
    async saveInfo() {
      return new Promise((resolve, reject) => {
        http.post(
          "/salesman/update",
          {
            salesman: this.salesman
          },
          response => {
            this.salesman = response.data.data;
            return resolve(response.data.data);
          }
        );
      });
    },
    fetchAgencies() {
      http.get("/agency/no-sale", response => {
        if (response.data.data != null && response.data.data.length > 0) {
          this.allAgencies = response.data.data;
          this.agencyTotalRows = this.allAgencies.length;
        }
      });
    },
    enableAddingMode() {
      this.addMode = !this.addMode;
      if (this.addMode) {
        this.fetchAgencies();
        //document.body.classList.remove('sidebar-lg-show')
        // this.fields = this.shorterFields;
      } else {
        // document.body.classList.add('sidebar-lg-show')
        // this.fields = this.shorterFields;
      }
    },
    addAgency(item, index, button, isAddAll) {
      //  console.log(item);

      this.allAgencies.splice(index, 1);
      item._rowVariant = "success";
      item.isNew = 1;
      this.salesman.agencies.push(item);
    },
    giveBackAgency(item, index, button, isAddAll) {
      //  console.log(item);

      this.salesman.agencies.splice(index, 1);
      item._rowVariant = "";
      this.allAgencies.push(item);
    },
    addAllAgency() {
      if (this.hasNoSaleAgencies) {
        for (let i = 0; i < this.allAgencies.length; i++) {
          this.salesman.agencies.push(this.allAgencies[i]);
        }
        this.allAgencies = [];
      }
    },
    async syncAgencies() {
      alerts.ajaxConfirm(
        "Xác nhận cập nhật thông tin NV?",
        "question",
        this.doSyncAgencies
      );
    },
    async doSyncAgencies() {
      return new Promise((resolve, reject) => {
        http.post(
          "/salesman/sync-agencies",
          {
            sale_id: this.salesman.id,
            new_agencies: this.salesman.agencies,
            no_sale_agencies: this.allAgencies
          },
          response => {
            this.salesman = response.data.data;
            return resolve(response.data.data);
          }
        );
      });
    },
    validateBeforeSubmit() {
      this.$validator.validateAll().then(result => {
        if (result) {
          // eslint-disable-next-line
          alerts.ajaxConfirm("Xác nhận cập nhật thông tin NV?", this.saveInfo);
          return;
        }

        // alert('Correct them errors!');
      });
    }
  },
  computed: {
    hasNoSaleAgencies: function() {
      if (this.allAgencies == null || this.allAgencies.length == 0) {
        return false;
      }
      return true;
    }
  }
};
</script>

